import EventEmitter from "eventemitter3"
import type { GameAction } from "../shared/game/gameActions"

const gamesById = new Map<string, Game>()

export function getGameById(id: string): Game {
	return gamesById.get(id)!
}

interface Events {
	public_action: [GameAction]
	private_action: [string, GameAction]
	destroyed: []
}

export class Game extends EventEmitter<Events> {
	constructor(public id: string) {
		super()
	}

	start() {

	}

	private destroy() {
		gamesById.delete(this.id)
		this.emit("destroyed")
	}
}